#!/usr/bin/env python
# jet.py

"""
Author : peters 

Revision History:
File created on 06 Sep 2010.

"""

import os
import sys
import subprocess
import logging

from da.baseclasses.jobcontrol import PlatForm

class JetPlatForm(PlatForm):
    def __init__(self):
        self.Identifier     = 'NOAA jet'    # the identifier gives the platform name
        self.Version        = '1.0'     # the platform version used
        print self

    def GetJobTemplate(self,joboptions={}):
        """ Return the job template for a given computing system, and fill it with options from the dictionary provided as argument"""

        template = """#$ -N jobname \n"""+ \
                   """#$ -A jobaccount \n"""+ \
                   """#$ -pe jobnodes \n"""+ \
                   """#$ -l h_rt=jobtime \n"""+ \
                   """#$ -S jobshell \n"""+ \
                   """#$ -cwd \n"""+ \
                   """#$ -r y \n"""+ \
                   """#$ -j y \n"""+ \
                   """\n"""

        for k,v in joboptions.iteritems():
            while k in template:
                template = template.replace(k,v)

        return template

    def SubmitJob(self,jobfile):                   
        """ This method submits a jobfile to the queue, and returns the queue ID """
        
        cmd     = ['qsub',jobfile]
        output  = subprocess.Popen(cmd, stdout=subprocess.PIPE).communicate()[0]  ; logging.info(output)
        jobid   = output.split()[2]

        return jobid

    def KillJob(self,jobid):                   
        """ This method kills a running job """
        
        output = subprocess.Popen(['qdel',jobid], stdout=subprocess.PIPE).communicate()[0]  ; logging.info(output)

        return output

    def StatJob(self,jobid):                   
        """ This method gets the status of a running job """
        import subprocess
        
        #output = subprocess.Popen(['sgestat'], stdout=subprocess.PIPE).communicate()[0]  ; logging.info(output)

        return ''

if __name__ == "__main__":
    pass
